<template>
  <div>
    <RyzomHeader
      :enable-webig-bar="false"
      :menu-bullets="getMenu"
      :active-menu="getActivePage"
      @change-lang="changeLang"
      @click-play-now="clickPlayNowButton"
      @click-menu="clickMenuButton"
      @click-home="clickHomeButton"
      @click-login="clickLogin"
      :home-location="localePath('index')"
      :enable-login="true"
      :enable-play-now="false"
      :user="headerUser"
      @click-logout="clickLogout"
      close-click-outside-element
      ci-path="https://ci.ryzom.com"
      enable-languages
      use-nuxt-links
      burger-breakpoint="xl"
    ></RyzomHeader>
    <b-modal
      id="modal-play-now"
      ref="modal-play-now"
      centered
      hide-footer
      hide-header
      hide-header-close
      size="xl"
      body-bg-variant="dark"
      body-text-variant="white"
    >
      <ModalCloseButton @close="closeModal"></ModalCloseButton>
      <PlayNow></PlayNow>
    </b-modal>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
import RyzomHeader from '../../../node_modules/ryzom-web-common/src/components/RyzomHeader';
import PlayNow from '~/components/play-now';
import ModalCloseButton from '~/components/ModalCloseButton';
import Crosslinking from '~/components/mixins/Crosslinking';

export default {
  components: {
    RyzomHeader,
    ModalCloseButton,
    PlayNow,
  },
  mixins: [Crosslinking],
  computed: {
    ...mapGetters(['getActivePage']),
    ...mapGetters('ryauth', ['isAuthenticated', 'loggedInUser']),
    getMenu() {
      return [
        /* {
          key: 'home',
          to: this.localePath('index'),
          label: this.$t('menu.home'),
        }, */
        {
          key: 'universe',
          to: this.localePath('universe'),
          label: this.$t('menu.universe'),
        },
        {
          key: 'game',
          to: this.localePath('game'),
          label: this.$t('menu.gameInfo'),
        },
        {
          key: 'events',
          to: this.localePath('events'),
          label: this.$t('menu.events'),
        },
        {
          key: 'wiki',
          to: 'https://' + this.$i18n.locale + '.wiki.ryzom.com/',
          label: this.$t('menu.wiki'),
          target: '_blank',
        },
        {
          key: 'forums',
          to:
            'https://app.ryzom.com/app_forum/index.php?&lang=' +
            this.$i18n.locale,
          label: this.$t('menu.forums'),
        },
        {
          key: 'webapps',
          to: 'https://app.ryzom.com?lang=' + this.$i18n.locale,
          label: this.$t('menu.apps'),
        },
        {
          key: 'chat',
          to: 'https://chat.ryzom.com/',
          label: this.$t('menu.chat'),
          target: '_blank',
        },
      ];
    },
    headerUser() {
      if (this.isAuthenticated) {
        return this.loggedInUser;
      }

      return null;
    },
  },
  methods: {
    changeLang(code) {
      this.$router.push(this.switchLocalePath(code));
    },
    clickPlayNowButton() {},
    closeModal() {
      this.$refs['modal-play-now'].hide();
    },
    clickMenuButton(to) {
      const currentLocale = this.$i18n.locale;

      if (to === 'forums') {
        const link = document.createElement('a');
        link.target = '_blank';
        link.href =
          'https://app.ryzom.com/app_forum/index.php?&lang=' + currentLocale;

        link.click();

        return;
      }

      if (to === 'wiki') {
        const link = document.createElement('a');
        link.target = '_blank';
        link.href = 'https://' + currentLocale + '.wiki.ryzom.com/';

        link.click();

        return;
      }

      this.$router.push(this.localePath(to));
    },
    clickHomeButton() {
      this.$router.push(this.localePath('index'));
    },
    clickLogin() {
      // this.toAccountManagement();
      this.$router.push(this.localePath('play'));
    },
    clickLogout() {
      this.$store.dispatch('ryauth/logout');
    },
  },
};
</script>
